Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponMode.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponMode.h	(revision 2918)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponMode.h	(revision 2918)
@@ -0,0 +1,246 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Polak
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _WeaponMode_H__
+#define _WeaponMode_H__
+
+#include "OrxonoxPrereqs.h"
+#include "core/BaseObject.h"
+
+#include "tools/Timer.h"
+#include "core/Identifier.h"
+#include "util/Math.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport WeaponMode : public BaseObject
+    {
+        public:
+            WeaponMode(BaseObject* creator);
+            virtual ~WeaponMode();
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+            bool fire(float* reloadTime);
+            bool reload();
+
+
+            // Munition
+            inline Munition* getMunition() const
+                { return this->munition_; }
+
+            void setMunitionType(Identifier* identifier);
+            inline Identifier* getMunitionType() const
+                { return this->munitiontype_; }
+
+            void setMunitionName(const std::string& munitionname);
+            inline const std::string& getMunitionName() const
+                { return this->munitionname_; }
+
+            inline void setInitialMunition(unsigned int amount)
+                { this->initialMunition_ = amount; }
+            inline unsigned int getInitialMunition() const
+                { return this->initialMunition_; }
+
+            inline void setInitialMagazines(unsigned int amount)
+                { this->initialMagazines_ = amount; }
+            inline unsigned int getInitialMagazines() const
+                { return this->initialMagazines_; }
+
+            inline void setMunitionPerShot(unsigned int amount)
+                { this->munitionPerShot_ = amount; }
+            inline unsigned int getMunitionPerShot() const
+                { return this->munitionPerShot_; }
+
+
+            // Reloading
+            inline void setReloadTime(float time)
+                { this->reloadTime_ = time; }
+            inline float getReloadTime() const
+                { return this->reloadTime_; }
+
+            inline void setAutoReload(bool autoreload)
+                { this->bAutoReload_ = autoreload; }
+            inline bool getAutoReload() const
+                { return this->bAutoReload_; }
+
+            inline void setParallelReload(bool parallelreload)
+                { this->bParallelReload_ = parallelreload; }
+            inline bool getParallelReload() const
+                { return this->bParallelReload_; }
+
+
+            // Fire
+            inline void setDamage(float damage)
+                { this->damage_ = damage; }
+            inline float getDamage() const
+                { return this->damage_; }
+
+            inline void setMuzzleOffset(const Vector3& offset)
+                { this->muzzleOffset_ = offset; }
+            inline const Vector3& getMuzzleOffset() const
+                { return this->muzzleOffset_; }
+
+            Vector3 getMuzzlePosition() const;
+            const Quaternion& getMuzzleOrientation() const;
+            Vector3 getMuzzleDirection() const;
+
+
+            // Weapon
+            inline void setWeapon(Weapon* weapon)
+                { this->weapon_ = weapon; this->updateMunition(); }
+            inline Weapon* getWeapon() const
+                { return this->weapon_; }
+
+            inline void setMode(unsigned int mode)
+                { this->mode_ = mode; }
+            inline unsigned int getMode() const
+                { return this->mode_; }
+
+        protected:
+            virtual void fire() = 0;
+
+            unsigned int initialMunition_;
+            unsigned int initialMagazines_;
+            unsigned int munitionPerShot_;
+
+            float reloadTime_;
+            bool bAutoReload_;
+            bool bParallelReload_;
+
+            float damage_;
+            Vector3 muzzleOffset_;
+
+        private:
+            void updateMunition();
+            void reloaded();
+
+            Weapon* weapon_;
+            unsigned int mode_;
+
+            Munition* munition_;
+            SubclassIdentifier<Munition> munitiontype_;
+            std::string munitionname_;
+
+            Timer<WeaponMode> reloadTimer_;
+            bool bReloading_;
+/*
+            virtual void fire();
+            void attachNeededMunition(const std::string& munitionType);
+            Munition * getAttachedMunition(const std::string& munitiontype);
+
+            //reloading
+            void bulletTimer(float bulletLoadingTime);
+            void magazineTimer(float magazineLoadingTime);
+            void bulletReloaded();
+            void magazineReloaded();
+
+            //get and set functions for XMLPort
+            void setMunitionType(const std::string& munitionType)
+                {   this->munitionType_ = munitionType; }
+            std::string& getMunitionType() const
+                {   return this->munitionType_;  }
+
+            void setBulletLoadingTime(float loadingTime)
+                {   this->bulletLoadingTime_ = loadingTime; }
+            float getBulletLoadingTime() const
+                {   return this->bulletLoadingTime_;  }
+
+            void setMagazineLoadingTime(float loadingTime)
+                {   this->magazineLoadingTime_ = loadingTime; }
+            float getMagazineLoadingTime() const
+                {   return this->magazineLoadingTime_;  }
+
+            void setBulletAmount(unsigned int amount)
+                {   this->bulletAmount_ = amount; }
+            unsigned int getBulletAmount() const
+                {   return this->bulletAmount_;  }
+
+            void setMagazineAmount(unsigned int amount)
+                {   this->magazineAmount_ = amount; }
+            unsigned int getMagazineAmount() const
+                {   return this->magazineAmount_;   }
+
+            void setUnlimitedMunition(bool unlimitedMunition)
+                {   this->unlimitedMunition_ = unlimitedMunition;   }
+            bool getUnlimitedMunition() const
+                {   return this->unlimitedMunition_;    }
+
+            //weapon actions
+            //these function are defined in the weapon classes
+            virtual void takeBullets() {}
+            virtual void takeMagazines() {}
+            virtual void createProjectile() {}
+            virtual void reloadBullet() {}
+            virtual void reloadMagazine() {}
+
+            //manually set or reset
+            virtual void setWeapon();
+            virtual void setMunition();
+
+            inline void setWeaponSystem(WeaponSystem *weaponSystem)
+                { this->weaponSystem_ = weaponSystem; };
+            inline WeaponSystem * getWeaponSystem() const
+                { return this->weaponSystem_; };
+
+            inline void setWeaponPack(WeaponPack *weaponPack)
+                { this->weaponPack_ = weaponPack; };
+            inline WeaponPack * getWeaponPack() const
+                { return this->weaponPack_; };
+
+            inline void setWeaponSlot(WeaponSlot * wSlot)
+                { this->weaponSlot_ = wSlot; }
+            inline WeaponSlot * getWeaponSlot() const
+                { return this->weaponSlot_; }
+
+        protected:
+            bool bReloading_;
+            bool bulletReadyToShoot_;
+            bool magazineReadyToShoot_;
+            bool unlimitedMunition_;
+            float bulletLoadingTime_;
+            float magazineLoadingTime_;
+            unsigned int bulletAmount_;
+            unsigned int magazineAmount_;
+            std::string munitionType_;
+
+            WeaponSlot * weaponSlot_;
+            Munition * munition_;
+            WeaponSystem * weaponSystem_;
+            WeaponPack* weaponPack_;
+
+            SubclassIdentifier<Munition> munitionIdentifier_;
+
+            Timer<WeaponMode> bulletReloadTimer_;
+            Timer<WeaponMode> magazineReloadTimer_;
+*/
+    };
+}
+
+#endif /* _WeaponMode_H__ */
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponPack.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponPack.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponPack.cc	(revision 2918)
@@ -72,5 +72,5 @@
         SUPER(WeaponPack, XMLPort, xmlelement, mode);
 
-        XMLPortObject(WeaponPack, Weapon, "", addWeapon, getWeapon, xmlelement, mode);
+        XMLPortObjectExtended(WeaponPack, Weapon, "", addWeapon, getWeapon, xmlelement, mode, false, false);
         XMLPortObject(WeaponPack, DefaultWeaponmodeLink, "links", addDefaultWeaponmodeLink, getDefaultWeaponmodeLink, xmlelement, mode);
     }
@@ -79,5 +79,11 @@
     {
         for (std::set<Weapon *>::iterator it = this->weapons_.begin(); it != this->weapons_.end(); ++it)
-            (*it)->fire();
+            (*it)->fire(weaponmode);
+    }
+
+    void WeaponPack::reload()
+    {
+        for (std::set<Weapon *>::iterator it = this->weapons_.begin(); it != this->weapons_.end(); ++it)
+            (*it)->reload();
     }
 
@@ -114,19 +120,4 @@
     }
 
-    void WeaponPack::setWeaponSystemToAllWeapons()
-    {
-        for (std::set<Weapon *>::const_iterator it = this->weapons_.begin(); it != this->weapons_.end(); ++it)
-            (*it)->setWeaponSystem(this->weaponSystem_);
-    }
-
-    void WeaponPack::attachNeededMunitionToAllWeapons()
-    {
-        for (std::set<Weapon *>::const_iterator it = this->weapons_.begin(); it != this->weapons_.end(); ++it)
-        {
-            (*it)->attachNeededMunition((*it)->getMunitionType());
-            (*it)->setWeapon();
-        }
-    }
-
     void WeaponPack::addDefaultWeaponmodeLink(DefaultWeaponmodeLink* link)
     {
@@ -155,3 +146,9 @@
         return WeaponSystem::WEAPON_MODE_UNASSIGNED;
     }
+
+    void WeaponPack::notifyWeapons()
+    {
+        for (std::set<Weapon *>::const_iterator it = this->weapons_.begin(); it != this->weapons_.end(); ++it)
+            (*it)->setWeaponPack(this);
+    }
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponPack.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponPack.h	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponPack.h	(revision 2918)
@@ -48,4 +48,5 @@
 
             void fire(unsigned int weaponmode);
+            void reload();
 
             void addWeapon(Weapon * weapon);
@@ -61,16 +62,11 @@
             unsigned int getDesiredWeaponmode(unsigned int firemode) const;
 
-            inline void setWeaponSystem(WeaponSystem *weaponSystem)
-            {
-                this->weaponSystem_ = weaponSystem;
-                this->setWeaponSystemToAllWeapons();
-                this->attachNeededMunitionToAllWeapons();
-            }
+            inline void setWeaponSystem(WeaponSystem * weaponSystem)
+                { this->weaponSystem_ = weaponSystem; this->notifyWeapons(); }
             inline WeaponSystem * getWeaponSystem() const
                 { return this->weaponSystem_; }
 
         private:
-            void setWeaponSystemToAllWeapons();
-            void attachNeededMunitionToAllWeapons();
+            void notifyWeapons();
 
             std::set<Weapon *> weapons_;
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSet.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSet.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSet.cc	(revision 2918)
@@ -64,42 +64,4 @@
         XMLPortParam(WeaponSet, "firemode", setDesiredFiremode, getDesiredFiremode, xmlelement, mode);
     }
-/*
-    void WeaponSet::attachWeaponPack(WeaponPack *wPack)
-    {
-        if ( this->weaponSystem_->getWeaponSlotSize()>0 && wPack->getSize()>0 && ( wPack->getSize() <= this->weaponSystem_->getWeaponSlotSize() ) )
-        {
-            this->attachedWeaponPack_ = wPack;
-            int wPackWeapon = 0;    //WeaponCounter for Attaching
-
-            //should be possible to choose which slot to use
-            //attach every weapon of the weaponPack to a weaponSlot
-            for (  int i=0; i < wPack->getSize() ; i++  )
-            {
-                //at the moment this function only works for one weaponPack in the entire WeaponSystem...
-                //it also takes the first free weaponSlot...
-                if ( this->weaponSystem_->getWeaponSlot(i)->getAttachedWeapon() == 0 && this->weaponSystem_->getWeaponSlot(i) != 0) //if slot not full
-                {
-                    this->setWeaponSlots_.push_back( this->weaponSystem_->getWeaponSlot(i) );
-                    this->weaponSystem_->getWeaponSlot(i)->attachWeapon( wPack->getWeaponPointer(wPackWeapon) );
-                    this->weaponSystem_->getPawn()->attach( wPack->getWeaponPointer(wPackWeapon) );
-                    wPackWeapon++;
-                }
-                else
-                {
-                    for (int k=0; k < this->weaponSystem_->getWeaponSlotSize(); k++)
-                    {
-                        if ( this->weaponSystem_->getWeaponSlot(k)->getAttachedWeapon() == 0 )
-                        {
-                            this->setWeaponSlots_.push_back( this->weaponSystem_->getWeaponSlot(k) );
-                            this->weaponSystem_->getWeaponSlot(k)->attachWeapon( wPack->getWeaponPointer(wPackWeapon) );
-                            this->weaponSystem_->getPawn()->attach( wPack->getWeaponPointer(wPackWeapon) );
-                            wPackWeapon++;
-                        }
-                    }
-                }
-            }
-        }
-    }
-*/
 
     void WeaponSet::fire()
@@ -109,4 +71,11 @@
             if (it->second != WeaponSystem::WEAPON_MODE_UNASSIGNED)
                 it->first->fire(it->second);
+    }
+
+    void WeaponSet::reload()
+    {
+        // fire all WeaponPacks with their defined weaponmode
+        for (std::map<WeaponPack*, unsigned int>::iterator it = this->weaponpacks_.begin(); it != this->weaponpacks_.end(); ++it)
+            it->first->reload();
     }
 
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSet.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSet.h	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSet.h	(revision 2918)
@@ -47,7 +47,6 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-//            void attachWeaponPack(WeaponPack *wPack);
-
             void fire();
+            void reload();
 
             void setWeaponmodeLink(WeaponPack* weaponpack, unsigned int weaponmode);
@@ -66,5 +65,5 @@
 
         private:
-            WeaponSystem *weaponSystem_;
+            WeaponSystem * weaponSystem_;
             unsigned int desiredFiremode_;
             std::map<WeaponPack*, unsigned int> weaponpacks_;
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSlot.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSlot.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSlot.cc	(revision 2918)
@@ -64,5 +64,5 @@
         SUPER(WeaponSlot, XMLPort, xmlelement, mode);
 
-        // ...
+        // In the future, there might be parameters like allowed weapon types or max size of the weapon
     }
 
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSystem.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSystem.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSystem.cc	(revision 2918)
@@ -37,4 +37,5 @@
 #include "WeaponSet.h"
 #include "Weapon.h"
+#include "Munition.h"
 
 /* WeaponSystem
@@ -63,18 +64,15 @@
                 this->pawn_->setWeaponSystem(0);
 
-//            for (std::map<unsigned int, WeaponSet*>::iterator it = this->weaponSets_.begin(); it != this->weaponSets_.end(); )
-//                delete (it++)->second;
             while (!this->weaponSets_.empty())
                 delete (this->weaponSets_.begin()->second);
 
-//            for (std::set<WeaponPack*>::iterator it = this->weaponPacks_.begin(); it != this->weaponPacks_.end(); )
-//                delete (*(it++));
             while (!this->weaponPacks_.empty())
                 delete (*this->weaponPacks_.begin());
 
-//            for (std::vector<WeaponSlot*>::iterator it = this->weaponSlots_.begin(); it != this->weaponSlots_.end(); )
-//                delete (*(it++));
             while (!this->weaponSlots_.empty())
                 delete (*this->weaponSlots_.begin());
+
+            while (!this->munitions_.empty())
+                { delete (this->munitions_.begin()->second); this->munitions_.erase(this->munitions_.begin()); }
         }
     }
@@ -284,20 +282,4 @@
     }
 
-    void WeaponSystem::setNewMunition(const std::string& munitionType, Munition * munitionToAdd)
-    {
-        this->munitionSet_[munitionType] = munitionToAdd;
-    }
-
-
-    //returns the Pointer to the munitionType, if this munitionType doesn't exist returns 0, see Weapon::attachNeededMunition
-    Munition * WeaponSystem::getMunitionType(const std::string& munitionType) const
-    {
-        std::map<std::string, Munition *>::const_iterator it = this->munitionSet_.find(munitionType);
-        if (it != this->munitionSet_.end())
-            return it->second;
-        else
-            return 0;
-    }
-
     void WeaponSystem::fire(unsigned int firemode)
     {
@@ -306,3 +288,31 @@
             it->second->fire();
     }
+
+    void WeaponSystem::reload()
+    {
+        for (std::map<unsigned int, WeaponSet *>::iterator it = this->weaponSets_.begin(); it != this->weaponSets_.end(); ++it)
+            it->second->reload();
+    }
+
+    Munition * WeaponSystem::getMunition(SubclassIdentifier<Munition> * identifier)
+    {
+        if (!identifier || !identifier->getIdentifier())
+            return 0;
+
+        std::map<Identifier *, Munition *>::iterator it = this->munitions_.find(identifier->getIdentifier());
+        if (it != this->munitions_.end())
+        {
+            return it->second;
+        }
+        else if (identifier->getIdentifier()->isA(Class(Munition)))
+        {
+            Munition* munition = identifier->fabricate(this);
+            this->munitions_[identifier->getIdentifier()] = munition;
+            return munition;
+        }
+        else
+        {
+            return 0;
+        }
+    }
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSystem.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSystem.h	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponSystem.h	(revision 2918)
@@ -69,9 +69,7 @@
 
             void fire(unsigned int firemode);
+            void reload();
 
-
-            void setNewMunition(const std::string& munitionType, Munition * munitionToAdd);
-            void setNewSharedMunition(const std::string& munitionType, Munition * munitionToAdd);
-            Munition * getMunitionType(const std::string& munitionType) const;
+            Munition * getMunition(SubclassIdentifier<Munition> * identifier);
 
             inline void setPawn(Pawn * pawn)
@@ -96,5 +94,5 @@
             std::vector<WeaponSlot *> weaponSlots_;
             std::set<WeaponPack *> weaponPacks_;
-            std::map<std::string, Munition *> munitionSet_;
+            std::map<Identifier *, Munition *> munitions_;
             Pawn * pawn_;
     };
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/CMakeLists.txt	(revision 2918)
@@ -1,3 +1,4 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+  ReplenishingMunition.cc
   LaserGunMunition.cc
   FusionMunition.cc
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/FusionMunition.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/FusionMunition.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/FusionMunition.cc	(revision 2918)
@@ -40,17 +40,14 @@
         RegisterObject(FusionMunition);
 
-        //default if not defined in XML
-        this->maxBullets_ = 10;
-        this->maxMagazines_ = 100;
+        this->maxMunitionPerMagazine_ = 10;
+        this->maxMagazines_ = 10;
+        this->magazines_ = 10;
+
+        this->bUseSeparateMagazines_ = true;
+        this->bStackMunition_ = false;
+        this->reloadTime_ = 1.0f;
+
+        this->bAllowMunitionRefilling_ = true;
+        this->bAllowMultiMunitionRemovementUnderflow_ = true;
     }
-
-    FusionMunition::~FusionMunition()
-    {
-    }
-
-    void FusionMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-
-    }
-
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/FusionMunition.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/FusionMunition.h	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/FusionMunition.h	(revision 2918)
@@ -39,12 +39,5 @@
         public:
             FusionMunition(BaseObject* creator);
-            virtual ~FusionMunition();
-
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-
-
-        private:
-
-
+            virtual ~FusionMunition() {}
     };
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.cc	(revision 2918)
@@ -36,21 +36,20 @@
     CreateFactory(LaserGunMunition);
 
-    LaserGunMunition::LaserGunMunition(BaseObject* creator) : Munition(creator)
+    LaserGunMunition::LaserGunMunition(BaseObject* creator) : ReplenishingMunition(creator)
     {
         RegisterObject(LaserGunMunition);
 
-        //default if not defined in XML
-        this->maxBullets_ = 40;
-        this->maxMagazines_ = 100;
+        this->maxMunitionPerMagazine_ = 20;
+        this->maxMagazines_ = 1;
+        this->magazines_ = 1;
+
+        this->bUseSeparateMagazines_ = false;
+        this->bStackMunition_ = true;
+
+        this->bAllowMunitionRefilling_ = true;
+        this->bAllowMultiMunitionRemovementUnderflow_ = true;
+
+        this->replenishIntervall_ = 0.5f;
+        this->replenishMunitionAmount_ = 1;
     }
-
-    LaserGunMunition::~LaserGunMunition()
-    {
-    }
-
-    void LaserGunMunition::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-
-    }
-
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.h	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/LaserGunMunition.h	(revision 2918)
@@ -31,20 +31,13 @@
 
 #include "OrxonoxPrereqs.h"
-#include "objects/weaponSystem/Munition.h"
+#include "ReplenishingMunition.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport LaserGunMunition : public Munition
+    class _OrxonoxExport LaserGunMunition : public ReplenishingMunition
     {
         public:
             LaserGunMunition(BaseObject* creator);
-            virtual ~LaserGunMunition();
-
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-
-
-        private:
-
-
+            virtual ~LaserGunMunition() {}
     };
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/ReplenishingMunition.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/ReplenishingMunition.cc	(revision 2918)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/ReplenishingMunition.cc	(revision 2918)
@@ -0,0 +1,70 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "ReplenishingMunition.h"
+
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    CreateFactory(ReplenishingMunition);
+
+    ReplenishingMunition::ReplenishingMunition(BaseObject* creator) : Munition(creator)
+    {
+        RegisterObject(ReplenishingMunition);
+
+        this->replenishIntervall_ = 1.0f;
+        this->replenishMunitionAmount_ = 1;
+
+        // Use the timer to initialize itself after the first tick (because the real values for
+        // replenishIntervall_ and replenishMunitionAmount_ will be set in the constructor of the
+        // inheriting class, which comes after this constructor)
+        this->replenishingTimer_.setTimer(0.0f, false, this, createExecutor(createFunctor(&ReplenishingMunition::initializeTimer)));
+    }
+
+    void ReplenishingMunition::initializeTimer()
+    {
+        // Initialize the timer
+        this->replenishingTimer_.setTimer(this->replenishIntervall_, true, this, createExecutor(createFunctor(&ReplenishingMunition::replenish)));
+    }
+
+    void ReplenishingMunition::replenish()
+    {
+        // Make a temporary copy of bAllowMunitionRefilling_, because this might be disallowed in every
+        // case except the internal munition replenishing
+        bool temp = this->bAllowMunitionRefilling_;
+        this->bAllowMunitionRefilling_ = true;
+
+        // Replenish munition
+        this->addMunition(this->replenishMunitionAmount_);
+
+        // Write back the temporary value
+        this->bAllowMunitionRefilling_ = temp;
+    }
+}
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/ReplenishingMunition.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/ReplenishingMunition.h	(revision 2918)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/munitions/ReplenishingMunition.h	(revision 2918)
@@ -0,0 +1,56 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _ReplenishingMunition_H__
+#define _ReplenishingMunition_H__
+
+#include "OrxonoxPrereqs.h"
+#include "objects/weaponSystem/Munition.h"
+#include "tools/Timer.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport ReplenishingMunition : public Munition
+    {
+        public:
+            ReplenishingMunition(BaseObject* creator);
+            virtual ~ReplenishingMunition() {}
+
+        protected:
+            float replenishIntervall_;
+            unsigned int replenishMunitionAmount_;
+
+        private:
+            void replenish();
+            void initializeTimer();
+
+            Timer<ReplenishingMunition> replenishingTimer_;
+    };
+}
+
+#endif /* _ReplenishingMunition_H__ */
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/projectiles/Projectile.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/projectiles/Projectile.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/projectiles/Projectile.cc	(revision 2918)
@@ -101,4 +101,7 @@
         if (!this->bDestroy_ && GameMode::isMaster())
         {
+            if (otherObject == this->owner_)
+                return true;
+
             this->bDestroy_ = true;
 
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/projectiles/Projectile.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/projectiles/Projectile.h	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/projectiles/Projectile.h	(revision 2918)
@@ -51,4 +51,9 @@
             virtual void destroyedPawn(Pawn* pawn);
 
+            inline void setDamage(float damage)
+                { this->damage_ = damage; }
+            inline float getDamage() const
+                { return this->damage_; }
+
             inline void setOwner(Pawn* owner)
                 { this->owner_ = owner; }
